#include <gtk/gtk.h>
#include <string.h>
char name[15];

typedef struct _Widgets Widgets;
struct _Widgets
{
  GtkWidget *fname;
  GtkWidget *sname;
};


GdkPixbuf *create_pixbuf(const gchar *filename)
{
  GdkPixbuf *pixbuf;
  GError *error = NULL;

  pixbuf = gdk_pixbuf_new_from_file(filename, &error);
  if (!pixbuf)
    { 
      fprintf(stderr, "%s\n", error->message );
      g_error_free(error);
    }

  return pixbuf;
}


int choice_made(int argcs, Widgets *widg)
{
  g_print("Wants to tally vote\n");
  strcpy( name, gtk_entry_get_text((GtkEntry *)widg->fname));
  strcat( name, " " );
  strcat( name, gtk_entry_get_text((GtkEntry *)widg->sname));
  g_print("User entered %s\n", name );
  gtk_main_quit();
}


int LaunchVotingWindow(int argc, char **argv )
{
  GtkWidget *window;
  GtkWidget *frame;
  GtkWidget *label1;
  GtkWidget *labelf;
  GtkWidget *labels;
  GtkWidget *done;
  Widgets widg;

  gtk_init(&argc, &argv);

  window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title(GTK_WINDOW(window), "prog1" );
  gtk_window_set_default_size(GTK_WINDOW(window), 250, 180 );
  gtk_window_set_position(GTK_WINDOW(window), GTK_WIN_POS_CENTER);
  gtk_window_set_icon(GTK_WINDOW(window), create_pixbuf("emmes1.ico"));

  g_signal_connect( window, "destroy",
		   G_CALLBACK(gtk_main_quit), NULL );
  
  //Create a frame into which multiple widgets may be placed
  frame = gtk_fixed_new();

  //add the frame to the window
  gtk_container_add(GTK_CONTAINER(window), frame );

  //create a text entry widget for first name
  widg.fname = gtk_entry_new();

  //position text entry widget in the frame
  gtk_fixed_put(GTK_FIXED(frame), widg.fname, 10, 60 ); 

  //create a text entry widget for second name
  widg.sname = gtk_entry_new();

  //position text entry widget in the frame
  gtk_fixed_put(GTK_FIXED(frame), widg.sname, 200, 60 ); 
  
  //create and place a question label
  label1 = gtk_label_new("Name your favorite person:");
  gtk_fixed_put(GTK_FIXED(frame), label1, 70, 10 );

  //create and place a label for first name
  labelf = gtk_label_new("First");
  gtk_fixed_put(GTK_FIXED(frame), labelf, 70, 40 );

  //create and place a label for second name
  labels = gtk_label_new("Last");
  gtk_fixed_put(GTK_FIXED(frame), labels, 250, 40 );

  //create a done button
  done = gtk_button_new_with_label("Done");

  //position the done button in the frame
  gtk_fixed_put(GTK_FIXED(frame), done, 120, 140 ); 

  //connect the done button to a processing subroutine
  g_signal_connect(G_OBJECT(done), "clicked", G_CALLBACK(choice_made), &widg);

  gtk_widget_show_all( window );
  gtk_main();

}


int LaunchSummaryWindow(int argc, char **argv )
{
  GtkWidget *window;
  GtkWidget *frame;
  GtkWidget *done;
  GtkWidget *slabel;
  char summary[300] = "Thank you for voting for ";

  gtk_init(&argc, &argv);

  window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title(GTK_WINDOW(window), "Result" );
  gtk_window_set_default_size(GTK_WINDOW(window), 250, 180 );
  //gtk_window_set_position(GTK_WINDOW(window), GTK_WIN_POS_CENTER);
  gtk_window_set_icon(GTK_WINDOW(window), create_pixbuf("emmes1.ico"));

  g_signal_connect( window, "destroy",
		   G_CALLBACK(gtk_main_quit), NULL );

  //Create a frame into which multiple widgets may be placed
  frame = gtk_fixed_new();

  //add the frame to the window
  gtk_container_add(GTK_CONTAINER(window), frame );
  
   //create label with for summary
  strcat(summary, name);
  slabel = gtk_label_new(summary);

  //position label widget in the frame
  gtk_fixed_put(GTK_FIXED(frame), slabel, 10, 40 ); 

  //create a done button
  done = gtk_button_new_with_label("Done");

  //position the done button in the frame
  gtk_fixed_put(GTK_FIXED(frame), done, 80, 100 ); 

  //connect the done button to a processing subroutine
  g_signal_connect(G_OBJECT(done), "clicked", G_CALLBACK(gtk_main_quit), NULL);

  gtk_widget_show_all( window );
  gtk_main();

}


int main( int argc, char **argv )
{
  int argcs = argc;
  char **argvs = argv;

  //This is the main routine.  All gtk+ is in the subroutines
  LaunchVotingWindow( argcs, argvs );
  LaunchSummaryWindow( argc, argvs );
}

